import 'package:diplomaticquarterapp/core/service/AlHabibMedicalService/health-calculator/bariatrics-service.dart';
import 'package:diplomaticquarterapp/models/Appointments/DoctorListResponse.dart';
import 'package:diplomaticquarterapp/pages/BookAppointment/SearchResults.dart';
import 'package:diplomaticquarterapp/theme/colors.dart';
import 'package:diplomaticquarterapp/uitl/gif_loader_dialog_utils.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/uitl/utils_new.dart';
import 'package:diplomaticquarterapp/widgets/buttons/defaultButton.dart';
import 'package:diplomaticquarterapp/widgets/buttons/secondary_button.dart';
import 'package:diplomaticquarterapp/widgets/data_display/text.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:diplomaticquarterapp/widgets/transitions/fade_page.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

class OvulationResult extends StatelessWidget {
  var dateFrom;
  var dateTo;
  var conceivedDate;
  var deliveryDue;
  var babyAge;
  var babyAgeDays;

  OvulationResult({
    this.dateFrom,
    this.dateTo,
    this.deliveryDue,
    this.conceivedDate,
    this.babyAge,
    this.babyAgeDays,
  });

  //var newFormat = DateFormat("yy-MM-dd");

  @override
  Widget build(BuildContext context) {
    return AppScaffold(
      showNewAppBar: true,
      showNewAppBarTitle: true,
      isShowDecPage: false,
      appBarTitle: TranslationBase.of(context).ovulation,
      body: Column(
        children: [
          Expanded(
            child: SingleChildScrollView(
              child: Padding(
                padding: const EdgeInsets.all(21),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Text(
                      TranslationBase.of(context).ovulation,
                      style: TextStyle(
                        fontSize: 19,
                        letterSpacing: -1.14,
                        fontWeight: FontWeight.w600,
                      ),
                    ),
                    mHeight(20),
                    Text(
                      TranslationBase.of(context).ovulationPeriod,
                      style: TextStyle(
                        fontSize: 14,
                        letterSpacing: -0.56,
                        fontWeight: FontWeight.w600,
                        color: CustomColors.textColor,
                      ),
                    ),
                    mHeight(20),
                    showItem(TranslationBase.of(context).from, DateFormat.yMMMEd().format(dateFrom), titleColor: CustomColors.accentColor),
                    mHeight(12),
                    showItem(TranslationBase.of(context).to, DateFormat.yMMMEd().format(dateTo), titleColor: CustomColors.accentColor),
                    mHeight(12),
                    mDivider(CustomColors.devider),
                    mHeight(12),
                    Text(
                      TranslationBase.of(context).useFullInfo,
                      style: TextStyle(
                        fontSize: 14,
                        letterSpacing: -0.56,
                        color: CustomColors.accentColor,
                        fontWeight: FontWeight.w500,
                      ),
                    ),
                    mHeight(12),
                    showItem(TranslationBase.of(context).conceive, DateFormat.yMMMEd().format(conceivedDate)),
                    mHeight(12),
                    mDivider(CustomColors.devider),
                    mHeight(12),
                    showItem(TranslationBase.of(context).babyAge, babyAge <= 0 ? TranslationBase.of(context).babyAgeAvail : babyAge.toString() + TranslationBase.of(context).week),

                    mHeight(12),
                    mDivider(CustomColors.devider),
                    mHeight(12), showItem(TranslationBase.of(context).deliveryDue, DateFormat.yMMMEd().format(deliveryDue)),
                  ],
                ).withBorderedContainer,
              ),
            ),
          ),
          Container(
            margin: EdgeInsets.symmetric(horizontal: 16.0, vertical: 16.0),
            color: Colors.white,
            child: SecondaryButton(
              label: TranslationBase.of(context).viewDocList,
              color: CustomColors.accentColor,
              onTap: () {
                getDoctorsList(context);
              },
            ),
          ),
        ],
      ),
    );
  }

  Widget showItem(String title, String value, {Color titleColor}) {
    return Container(
      width: double.infinity,
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            title,
            style: TextStyle(
              fontSize: 14,
              letterSpacing: -0.56,
              color: titleColor ?? Colors.black,
              fontWeight: FontWeight.w500,
              // fontWeight: FontWeight.w600,
            ),
          ),
          Text(
            value,
            style: TextStyle(
              fontSize: 18,
              letterSpacing: -1.08,
              fontWeight: FontWeight.w600,
            ),
          ),
        ],
      ),
    );
  }

  getDoctorsList(BuildContext context) {
    GifLoaderDialogUtils.showMyDialog(context);
    BariatricsService service = new BariatricsService();

    List<DoctorList> doctorsList = [];
    List<PatientDoctorAppointmentList> _patientDoctorAppointmentListHospital = List();

    service.getCalculationDoctors(calculationID: 6).then((res) {
      GifLoaderDialogUtils.hideDialog(context);
      print(res['List_CalculationTable'].length);
      if (res['MessageStatus'] == 1) {
        if (res['List_CalculationTable'].length != 0) {
          res['List_CalculationTable'].forEach((item) {
            DoctorList docList = new DoctorList();
            docList.clinicID = item['ClinicID'];
            docList.clinicName = item['ClinicName'];
            docList.doctorID = item['DoctorID'];
            docList.doctorImageURL = item['DoctorImageURL'];
            docList.name = item['DoctorName'];
            docList.doctorTitle = item['DoctorTitle'];
            docList.gender = item['Gender'];
            docList.genderDescription = item['GenderDescription'];
            docList.nationalityName = item['Nationality'];
            docList.nationalityFlagURL = item['NationalityFlagURL'];
            docList.projectID = item['ProjectID'];
            docList.projectName = item['ProjectName'];
            docList.actualDoctorRate = 0;
            doctorsList.add(docList);
          });

          doctorsList.forEach((element) {
            List<PatientDoctorAppointmentList> doctorByHospital = _patientDoctorAppointmentListHospital
                .where(
                  (elementClinic) => elementClinic.filterName == element.projectName,
                )
                .toList();

            if (doctorByHospital.length != 0) {
              _patientDoctorAppointmentListHospital[_patientDoctorAppointmentListHospital.indexOf(doctorByHospital[0])].patientDoctorAppointmentList.add(element);
            } else {
              _patientDoctorAppointmentListHospital.add(PatientDoctorAppointmentList(filterName: element.projectName, distanceInKMs: "0", patientDoctorAppointment: element));
            }
          });

          Navigator.push(context, FadePage(page: SearchResults(isLiveCareAppointment: false, doctorsList: doctorsList, patientDoctorAppointmentListHospital: _patientDoctorAppointmentListHospital)));
        }
      }
    }).catchError((err) {
      GifLoaderDialogUtils.hideDialog(context);
      print(err);
    });
  }
}

extension BorderedContainer on Widget {
  Widget get withBorderedContainer => Container(
        padding: EdgeInsets.only(left: 16, right: 16, bottom: 15, top: 15),
        alignment: Alignment.center,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(15),
          color: Colors.white,
          border: Border.all(
            color: Color(0xffefefef),
            width: 1,
          ),
        ),
        child: this,
      );
}
